module InformantCommon
  module Model
    class ActiveModel < Base
      def initialize(active_model)
        self.id = active_model.object_id
        self.name = active_model.class.name
        self.errors = []
        active_model.errors.each do |field, error|
          add_error(field.to_s, extract_value(active_model, field), error)
        end
      end

      private

      def extract_value(active_model, field)
        active_model.public_send(field)
      rescue StandardError
        nil
      end
    end
  end
end
